/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.35
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {ErrorAuthenticationResponse} from '../model/ErrorAuthenticationResponse';
import {ErrorBadRequestResponse} from '../model/ErrorBadRequestResponse';
import {ErrorInternalServerResponse} from '../model/ErrorInternalServerResponse';
import {ErrorNotFoundResponse} from '../model/ErrorNotFoundResponse';
import {ErrorServiceNotAvailableResponse} from '../model/ErrorServiceNotAvailableResponse';
import {ErrorToManyRequestsResponse} from '../model/ErrorToManyRequestsResponse';
import {Job} from '../model/Job';
import {JobRecipients} from '../model/JobRecipients';
import {JobsIdBody} from '../model/JobsIdBody';
import {Notifications} from '../model/Notifications';
import {Preview} from '../model/Preview';
import {Templates} from '../model/Templates';

/**
* JobDetails service.
* @module api/JobDetailsApi
* @version 4.0.0
*/
export class JobDetailsApi {

    /**
    * Constructs a new JobDetailsApi. 
    * @alias module:api/JobDetailsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the getJob operation.
     * @callback moduleapi/JobDetailsApi~getJobCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Job{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /jobs/{id}
     * Description: Obtain information of a specific job
     * @param {String} id Identification number (UUID) of the job
     * @param {module:api/JobDetailsApi~getJobCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getJob(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getJob");
      }

      let pathParams = {
        'id': id
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Job;

      return this.apiClient.callApi(
        '/jobs/{id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the getJobNotifications operation.
     * @callback moduleapi/JobDetailsApi~getJobNotificationsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Notifications{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /jobs/{id}/notifications
     * Description: To obtain a list of notifications to a specific job
     * @param {String} id Identification number (UUID) of the job
     * @param {module:api/JobDetailsApi~getJobNotificationsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getJobNotifications(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getJobNotifications");
      }

      let pathParams = {
        'id': id
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Notifications;

      return this.apiClient.callApi(
        '/jobs/{id}/notifications', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the getJobPreviews operation.
     * @callback moduleapi/JobDetailsApi~getJobPreviewsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Preview{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /jobs/{id}/preview
     * Description: To obtain the preview pdf document of a specific job
     * @param {String} id Identification number (UUID) of the job
     * @param {module:api/JobDetailsApi~getJobPreviewsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getJobPreviews(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getJobPreviews");
      }

      let pathParams = {
        'id': id
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Preview;

      return this.apiClient.callApi(
        '/jobs/{id}/preview', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the getJobRecipients operation.
     * @callback moduleapi/JobDetailsApi~getJobRecipientsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/JobRecipients{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /jobs/{id}/recipients
     * Description: Resource to obtain a list of recipients to a specific job
     * @param {String} id Identification number (UUID) of the job
     * @param {Object} opts Optional parameters
     * @param {Number} opts.objectLimit Query parameter to change de default limitation of objects in the result data array (default to <.>)
     * @param {Number} opts.objectOffset Query parameter to change de default offset of objects in the result data array (default to <.>)
     * @param {String} opts.filterFaxNumber Query parameter to fetch recipients after his fax number
     * @param {String} opts.filterFaxNumberNorm Query parameter to fetch recipients after his normed fax number
     * @param {String} opts.filterRecipientReference Query parameter to fetch recipients after his recipient reference
     * @param {String} opts.filterInternationalDialingCode Query parameter to fetch recipients after his international dialing code
     * @param {String} opts.filterResultCode Query parameter to fetch recipients after his result code
     * @param {String} opts.filterResultText Query parameter to fetch recipients after his result text
     * @param {module:model/String} opts.sortField Available sort options for the result data array.
     * @param {module:model/String} opts.sortOrder Describes the order for used sort fields (default to <.>)
     * @param {module:api/JobDetailsApi~getJobRecipientsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getJobRecipients(id, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getJobRecipients");
      }

      let pathParams = {
        'id': id
      };
      let queryParams = {
        'objectLimit': opts['objectLimit'],'objectOffset': opts['objectOffset'],'filterFaxNumber': opts['filterFaxNumber'],'filterFaxNumberNorm': opts['filterFaxNumberNorm'],'filterRecipientReference': opts['filterRecipientReference'],'filterInternationalDialingCode': opts['filterInternationalDialingCode'],'filterResultCode': opts['filterResultCode'],'filterResultText': opts['filterResultText'],'sortField': opts['sortField'],'sortOrder': opts['sortOrder']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = JobRecipients;

      return this.apiClient.callApi(
        '/jobs/{id}/recipients', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the getJobTemplates operation.
     * @callback moduleapi/JobDetailsApi~getJobTemplatesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Templates{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /jobs/{id}/templates
     * Description: To obtain a list of template documents to a specific job
     * @param {String} id Identification number (UUID) of the job
     * @param {module:api/JobDetailsApi~getJobTemplatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getJobTemplates(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getJobTemplates");
      }

      let pathParams = {
        'id': id
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Templates;

      return this.apiClient.callApi(
        '/jobs/{id}/templates', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the putJob operation.
     * @callback moduleapi/JobDetailsApi~putJobCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Job{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /jobs/{id}
     * Description: Control the transmission of the specific job
     * @param {module:model/JobsIdBody} body Describes the required request body to perform an action on the fax job
     * @param {String} id Identification number (UUID) of the job
     * @param {module:api/JobDetailsApi~putJobCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    putJob(body, id, callback) {
      
      let postBody = body;
      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling putJob");
      }
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling putJob");
      }

      let pathParams = {
        'id': id
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = Job;

      return this.apiClient.callApi(
        '/jobs/{id}', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}